SPOOL .\Logs\00-Tablespace_y_usuario.log
PROMPT Generando tablespace y usuario... 

/************************************************************************************************************************
*                                                                                                                       *
* Nombre........: 01-Tablespace_y_usuario.sql                                                                           *
* Descripcin...: Crea el espacio de almacenamiento y el usuario empleado para el proyecto                              *
*                                                                                                                       *
* Pasos a seguir:                                                                                                       *
*                                                                                                                       *
*     1.- Una vez ejecutadas las sentencias es necesario crear una nueva conexin con el tablespace y el usuario creado *
*                                                                                                                       *
*************************************************************************************************************************/

-- Tablespace

DROP TABLESPACE TS_TFC INCLUDING CONTENTS AND DATAFILES;

CREATE TABLESPACE TS_TFC LOGGING
DATAFILE 'C:\oraclexe\app\oracle\oradata\XE\TS_TFC.DBF' SIZE 100 M
EXTENT MANAGEMENT LOCAL SEGMENT SPACE MANAGEMENT AUTO;

-- Usuario

DROP USER UOC CASCADE;

CREATE USER UOC PROFILE DEFAULT IDENTIFIED BY "UOC"
DEFAULT TABLESPACE TS_TFC TEMPORARY TABLESPACE TEMP ACCOUNT UNLOCK;

GRANT CONNECT, RESOURCE TO UOC;

-- Asignar privilegios, 

GRANT ALL PRIVILEGES TO UOC;

SPOOL OFF;