SET serveroutput ON;

SPOOL .\Logs\14-Pruebas_Realizadas.log;
PROMPT Iniciando pruebas... 
PROMPT 
PROMPT Limpia las tablas a probar...
PROMPT
	
  DELETE FROM ESTADISTICO;
  DELETE FROM HECHO;
  DELETE FROM PRODUCTO PRODUCTO;
  DELETE FROM TIENDA;
  DELETE FROM TIEMPO;
  DELETE FROM LOG_ACTIVIDAD;

PROMPT
PROMPT Inicializa contadores de secuencia...  
PROMPT

  
  @03-Secuencias_y_triggers.sql;
  
DECLARE 

	O_RSP          VARCHAR2(250 CHAR);
    O_Verificacion VARCHAR2(250 CHAR);
	
BEGIN

    DBMS_OUTPUT.PUT_LINE('Analizando posibles incidencias al insertar una tienda');
	DBMS_OUTPUT.PUT_LINE('------------------------------------------------------');
	
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda(NULL, NULL, NULL, NULL, NULL, NULL, NULL, O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Todos');
	DBMS_OUTPUT.PUT_LINE('Muestra el primer error detectado');
	DBMS_OUTPUT.PUT_LINE(O_RSP);

	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda(NULL, 1, 1, 'Tienda_1@gmail.com', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Nombre');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda('Tienda_1', NULL, 1, 'Tienda_1@gmail.com', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Ciudad');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda('Tienda_1', NULL, 1, 'Tienda_1@gmail.com', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Región');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda('Tienda_1', 1, 1, NULL, 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: E-Mail');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda('Tienda_1', 1, 1, 'Tienda_1@gmail.com', NULL, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Trabajadores');
	DBMS_OUTPUT.PUT_LINE(O_RSP);

    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda('Tienda_1', 1, 1, 'Tienda_1@gmail.com', 5, NULL, 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Franquicia');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda('Tienda_1', 1, 1, 'Tienda_1@gmail.com', 5, 'N', NULL, O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Virtual');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda('Tienda_1', 1, 1, 'Tienda_1@gmail.com', 5, 'Y', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando franquicia distinta de N/S');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda('Tienda_1', 1, 1, 'Tienda_1@gmail.com', 5, 'N', 'Y', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando virtual distinta de N/S');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda('Tienda_1', 50, 1, 'Tienda_1@gmail.com', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('La ciudad informada no existe');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda('Tienda_1', 1, 50, 'Tienda_1@gmail.com', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('La región informada no existe');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda('Tienda_1', 1, 1, 'Tienda_1', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('El E-Mail informado no es correcto: Tienda_1');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda('Tienda_1', 1, 1, 'Tienda_1@gmail.com', 0, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('El número de trabajadores debe ser mayor de cero');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda('Tienda_1', 1, 1, 'Tienda_1@gmail.com', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Registra correctamente la tienda');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_insertar_tienda('Tienda_1', 1, 1, 'Tienda_1@gmail.com', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Intentando dar de alta nuevamente la tienda');
	DBMS_OUTPUT.PUT_LINE(O_RSP);

    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');	
	DBMS_OUTPUT.PUT_LINE('Analizando posibles incidencias al modificar una tienda');
	DBMS_OUTPUT.PUT_LINE('------------------------------------------------------');
	
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Todos');
	DBMS_OUTPUT.PUT_LINE('Muestra el primer error detectado');
	DBMS_OUTPUT.PUT_LINE(O_RSP);

	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(1, NULL, 1, 1, 'Tienda_1@gmail.com', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Nombre');
	Select MAX(V_Nombre) INTO O_Verificacion from tienda where I_Tienda = 1;
	DBMS_OUTPUT.PUT_LINE('Mantiene el valor existente: ' || TRIM(O_Verificacion));	
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(1, 'Tienda_1', NULL, 1, 'Tienda_1@gmail.com', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Ciudad');
	Select MAX(I_Ciudad) INTO O_Verificacion from tienda where I_Tienda = 1;
	DBMS_OUTPUT.PUT_LINE('Mantiene el valor existente: ' || TRIM(O_Verificacion));
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(1, 'Tienda_1', NULL, 1, 'Tienda_1@gmail.com', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Región');
	Select MAX(I_Region) INTO O_Verificacion from tienda where I_Tienda = 1;
	DBMS_OUTPUT.PUT_LINE('Mantiene el valor existente: ' || TRIM(O_Verificacion));
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(1, 'Tienda_1', 1, 1, NULL, 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: E-Mail');
	Select MAX(V_Email) INTO O_Verificacion from tienda where I_Tienda = 1;
	DBMS_OUTPUT.PUT_LINE('Mantiene el valor existente: ' || TRIM(O_Verificacion));
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(1, 'Tienda_1', 1, 1, 'Tienda_1@gmail.com', NULL, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Trabajadores');
	Select MAX(N_Trabajadores) INTO O_Verificacion from tienda where I_Tienda = 1;
	DBMS_OUTPUT.PUT_LINE('Mantiene el valor existente: ' || TRIM(O_Verificacion));
	DBMS_OUTPUT.PUT_LINE(O_RSP);

    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(1, 'Tienda_1', 1, 1, 'Tienda_1@gmail.com', 5, NULL, 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Franquicia');
	Select MAX(V_Franquicia) INTO O_Verificacion from tienda where I_Tienda = 1;
	DBMS_OUTPUT.PUT_LINE('Mantiene el valor existente: ' || TRIM(O_Verificacion));
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(1, 'Tienda_1', 1, 1, 'Tienda_1@gmail.com', 5, 'N', NULL, O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Virtual');
	Select MAX(V_Virtual) INTO O_Verificacion from tienda where I_Tienda = 1;
	DBMS_OUTPUT.PUT_LINE('Mantiene el valor existente: ' || TRIM(O_Verificacion));
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(1, 'Tienda_1', 1, 1, 'Tienda_1@gmail.com', 5, 'Y', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando franquicia distinta de N/S');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(1, 'Tienda_1', 1, 1, 'Tienda_1@gmail.com', 5, 'N', 'Y', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando virtual distinta de N/S');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(2, 'Tienda_1', 50, 1, 'Tienda_1@gmail.com', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('La tienda informada no existe');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(1, 'Tienda_1', 50, 1, 'Tienda_1@gmail.com', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('La ciudad informada no existe');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(1, 'Tienda_1', 1, 50, 'Tienda_1@gmail.com', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('La región informada no existe');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(1, 'Tienda_1', 1, 1, 'Tienda_1', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('El E-Mail informado no es correcto: Tienda_1');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(1, 'Tienda_1', 1, 1, 'Tienda_1@gmail.com', 0, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('El número de trabajadores debe ser mayor de cero');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_actualizar_tienda(1, 'Tienda_2', 1, 1, 'Tienda_1@gmail.com', 5, 'N', 'N', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Actualiza correctamente la descripción de la tienda');
	Select MAX(V_Nombre) INTO O_Verificacion from tienda where I_Tienda = 1;
	DBMS_OUTPUT.PUT_LINE('Nueva descripción: ' || TRIM(O_Verificacion));
	DBMS_OUTPUT.PUT_LINE(O_RSP);

	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');	
	DBMS_OUTPUT.PUT_LINE('Analizando posibles incidencias al eliminar una tienda');
	DBMS_OUTPUT.PUT_LINE('------------------------------------------------------');
	
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_eliminar_tienda(NULL, O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos');
	DBMS_OUTPUT.PUT_LINE(O_RSP);	
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_eliminar_tienda(5, O_RSP);
	DBMS_OUTPUT.PUT_LINE('Se intenta eliminar una tienda inexistente');
	DBMS_OUTPUT.PUT_LINE(O_RSP);	
	
	UPDATE TIENDA SET F_ELIMINACION = SYSTIMESTAMP WHERE I_TIENDA = 1;
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_TIENDAS.usp_eliminar_tienda(1, O_RSP);
	DBMS_OUTPUT.PUT_LINE('Se intenta eliminar una tienda anulada logícamente');
	DBMS_OUTPUT.PUT_LINE(O_RSP);	
	
	DBMS_OUTPUT.PUT_LINE('Analizando posibles incidencias al insertar una producto');
	DBMS_OUTPUT.PUT_LINE('--------------------------------------------------------');
	
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_insertar_producto(NULL, NULL, NULL, O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Todos');
	DBMS_OUTPUT.PUT_LINE('Muestra el primer error detectado');
	DBMS_OUTPUT.PUT_LINE(O_RSP);

	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_insertar_producto(NULL, 'Producto_1', '10/01/2016', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Código de producto');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_insertar_producto(8412345678905, NULL, '10/01/2016', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Descripción');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_insertar_producto(8412345678905, 'Producto_1', NULL, O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Fecha incorporación al catálogo');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_insertar_producto(1, 'Producto_1', '10/01/2016', O_RSP);
	DBMS_OUTPUT.PUT_LINE('El código de producto informado no es correcto');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_insertar_producto(8412345678905, 'Producto_1', '10/01/2016', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Registra correctamente el producto');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_insertar_producto(8412345678905, 'Producto_1', '10/01/2016', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Intentando dar de alta nuevamente el producto');
	DBMS_OUTPUT.PUT_LINE(O_RSP);

	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');	
	DBMS_OUTPUT.PUT_LINE('Analizando posibles incidencias al modificar una tienda');
	DBMS_OUTPUT.PUT_LINE('------------------------------------------------------');
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_actualizar_producto(NULL, 'Producto_1', '10/01/2016', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Código de producto');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_actualizar_producto(8412345678905, NULL, '10/01/2016', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Descripción');
	Select MAX(V_Descripcion) INTO O_Verificacion from producto  where N_Producto = 8412345678905;
	DBMS_OUTPUT.PUT_LINE('Mantiene el valor existente: ' || TRIM(O_Verificacion));
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_actualizar_producto(8412345678905, 'Producto_1', NULL, O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Fecha incorporación al catálogo');
	Select MAX(F_Incorporacion) INTO O_Verificacion from producto where N_Producto = 8412345678905;
	DBMS_OUTPUT.PUT_LINE('Mantiene el valor existente: ' || TRIM(O_Verificacion));
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_actualizar_producto(1, 'Producto_1', '10/01/2016', O_RSP);
	DBMS_OUTPUT.PUT_LINE('El código de producto informado no es correcto');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_actualizar_producto(8412345678905, 'Producto_2', '10/01/2016', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Actualiza correctamente la descripción del producto');
	Select MAX(V_Descripcion) INTO O_Verificacion from producto where N_Producto = 8412345678905;
	DBMS_OUTPUT.PUT_LINE('Nueva descripción: ' || TRIM(O_Verificacion));
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_actualizar_producto(8412345678905, 'Producto_1', '11/01/2016', O_RSP);
	DBMS_OUTPUT.PUT_LINE('Actualiza correctamente la fecha de incorporación del producto');
	Select MAX(F_Incorporacion) INTO O_Verificacion from producto where N_Producto = 8412345678905;
	DBMS_OUTPUT.PUT_LINE('Nueva descripción: ' || TRIM(O_Verificacion));
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');	
	DBMS_OUTPUT.PUT_LINE('Analizando posibles incidencias al eliminar un producto');
	DBMS_OUTPUT.PUT_LINE('-------------------------------------------------------');
	
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_eliminar_producto(NULL, O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos');
	DBMS_OUTPUT.PUT_LINE(O_RSP);	
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_eliminar_producto(5, O_RSP);
	DBMS_OUTPUT.PUT_LINE('Se intenta eliminar un producto inexistente');
	DBMS_OUTPUT.PUT_LINE(O_RSP);	
	
	UPDATE PRODUCTO SET F_ELIMINACION = SYSTIMESTAMP WHERE N_Producto = 8412345678905;
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_PRODUCTOS.usp_eliminar_producto(8412345678905, O_RSP);
	DBMS_OUTPUT.PUT_LINE('Se intenta eliminar un producto anulado logícamente');
	DBMS_OUTPUT.PUT_LINE(O_RSP);	
	
	DBMS_OUTPUT.PUT_LINE('Analizando posibles incidencias al insertar una hecho');
	DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
	
	UPDATE TIENDA   SET F_ELIMINACION = NULL WHERE I_TIENDA = 1;
	UPDATE PRODUCTO SET F_ELIMINACION = NULL WHERE N_Producto = 8412345678905;
	
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Todos');
	DBMS_OUTPUT.PUT_LINE('Muestra el primer error detectado');
	PK_HECHOS.usp_insertar_hecho(NULL, NULL, NULL, NULL, NULL, NULL, NULL,  O_RSP);

	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Tienda');
	PK_HECHOS.usp_insertar_hecho(NULL, 8412345678905, '10/01/2016', 16, 1, 2, 3,  O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_HECHOS.usp_insertar_hecho(1, NULL, '10/01/2016', 16, 1, 2, 3,  O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Producto');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_HECHOS.usp_insertar_hecho(1, 8412345678905, NULL, 16, 1, 2, 3,  O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Fecha de la venta');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_HECHOS.usp_insertar_hecho(1, 8412345678905, '10/01/2016', NULL, 1, 2, 3,  O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Hora');
	
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_HECHOS.usp_insertar_hecho(1, 8412345678905, '10/01/2016', 16, NULL, 2, 3,  O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Cantidad vendida');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_HECHOS.usp_insertar_hecho(1, 8412345678905, '10/01/2016', 16, 1, NULL, 3,  O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Precio bruto');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_HECHOS.usp_insertar_hecho(1, 8412345678905, '10/01/2016', 16, 1, 2, NULL,  O_RSP);
	DBMS_OUTPUT.PUT_LINE('Analizando valores nulos: Beneficio neto');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_HECHOS.usp_insertar_hecho(1, 1, '10/01/2016', 16, 1, 2, 3,  O_RSP);
	DBMS_OUTPUT.PUT_LINE('El código de producto no es el adecuado');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_HECHOS.usp_insertar_hecho(1, 8412345678905, '10/01/2016', 16, 1, 2, 3,  O_RSP);
	DBMS_OUTPUT.PUT_LINE('Registra correctamente el hecho');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_HECHOS.usp_actualizar_hecho(1, 8412345678905, '10/01/2016', 16, 1, 2, 8,  O_RSP);
	DBMS_OUTPUT.PUT_LINE('Actualiza correctamente el hecho');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
	DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' ');
	PK_HECHOS.usp_insertar_hecho(1, 8412345678905, '25/01/2016', 16, 1, 2, 8,  O_RSP);
	DBMS_OUTPUT.PUT_LINE('Inserta venta posterior a la fecha actual');
	DBMS_OUTPUT.PUT_LINE(O_RSP);
	
END;

/

PROMPT
PROMPT
SELECT * FROM TABLE(PK_CONSULTAS.f_Consulta_A(2016,1));

PROMPT
PROMPT
SELECT * FROM TABLE(PK_CONSULTAS.f_Consulta_B(2016,1));

PROMPT
PROMPT	
SELECT * FROM TABLE(PK_CONSULTAS.f_Consulta_C(2016,1));

PROMPT
PROMPT	
SELECT * FROM TABLE(PK_CONSULTAS.f_Consulta_H(2016));

PROMPT
PROMPT	
SELECT * FROM TABLE(PK_CONSULTAS.f_Consulta_H(NULL));

/

SPOOL OFF;
