/************************************************************************************************************************
*                                                                                                                       *  
* Nombre........: 01 - Generacion.sql                                                                                   *
* Descripcin...: Gestiona las distintas etapas asocidas a la base de datos                                             *
*                                                                                                                       *
* Pasos a seguir:                                                                                                       *
*                                                                                                                       *
*     1.- Conectarse a la base de datos con un usuario que tenga permisos de administrador.                             *
*     2.- Situar los scripts en una carpeta que sea accesible desde ORACLE SQL Developer.                               *
*         Se puede configurar en: Men Herramientas - Preferencias - Base de datos - Hoja de trabajo                    *
*     3.- Crear dentro de esta carpeta, una subcarpeta llamada Logs.                                                    *
*         Almacenar el resultado de la ejecucin de los diferentes scripts.                                            * 
*     4.- En el caso de querer ejecutar el proceso manualmente, es necesario respetar el orden indicado en cada         *
*         uno de los archivos.                                                                                          *
*************************************************************************************************************************/

@02-Tablas.sql;
@03-Secuencias_y_triggers.sql;
@04-Tipos.sql;
@05-Datos_iniciales.sql;
@06-Package_Procedimientos.sql;
@07-Package_Funciones.sql;
@08-Package_Verificacion.sql;
@09-Package_Tiendas.sql;
@10-Package_Productos.sql;
@11-Package_Hechos.sql;
@12-Package_Consultas.sql;
@13-Package_Historicos.sql;
@14-Pruebas_Realizadas.sql;